from subprocess import *
import re
from trac.core import *
from trac.perm import IPermissionGroupProvider

class UnixGroups(Component):
    implements(IPermissionGroupProvider)

    # IPermissionGroupProvider methods
    def get_permission_groups(self, username):
	
	# Use id to get a record on the user
	record = Popen(["id", username], stdout=PIPE).communicate()[0]
	
	# Chunk the record into a list of the parenthesized strings
	# you get an empty list here if the user doesn't exist
	seperated = re.findall ( "\([a-zA-Z\\\\ _0-9]*\)"  , record )
	
	# Chop off the username and the primary group name
	del seperated[:2]

	# Function for prettifying the names
	def removeparens(group):
		parens = re.compile ( '(\(|\))' )
		return parens.sub ( '' , group)
	
	# Return a prettified list of groups
	return map( removeparens, seperated )

